function [coordinates] = simulatedAnnealing(domain,neighborDistance,initialTemperature)
	coordinates = generateRandomCoordinates(domain);
	alpha = 0.999;
	value = func(coordinates);
	temperature = initialTemperature;
	while (temperature/alpha) - temperature > eps
		neighbors = getNeighborhood(coordinates,neighborDistance,domain);
		for i = 1:length(neighbors);
			neighborsValue=func(neighbors(i).coordinates);
			deltaE = value - neighborsValue;
			if deltaE > 0
				coordinates = neighbors(i).coordinates;
				value = neighborsValue;
				break;
			else 
				probabilityOfAccept = exp((deltaE)/temperature);
				probOcurrence = rand();
				if(probOcurrence <= probabilityOfAccept)
					coordinates = neighbors(i).coordinates;
					value = neighborsValue;
				endif
			endif
		endfor
		temperature = alpha*temperature;
	endwhile
endfunction
